Properties Methods Events Config Options Direct Link

    Observable
      Component
        Editor
          TreeEditor

# Class Ext.tree.TreeEditor

Package: | Ext.tree
Defined In: | TreeEditor.js
Class: | TreeEditor
Extends: | Editor

Provides editor functionality for inline tree node editing. Any valid Ext.form.Field subclass can be used as the editor field.

## Config Options

Config Options | Defined By
--- | ---
| alignment : String The position to align to (see Ext.Element.alignTo for more details, defaults to "l-l"). | TreeEditor
| allowBlur : Boolean True to complete the editing process if in edit mode when the field is blurred. Defaults to `true`. | Editor
| allowDomMove : Boolean Whether the component can move the Dom node when rendering (defaults to true). | Component

applyTo : Mixed
Specify the id of the element, a DOM element or an existing Element corresponding to a DIV that is already present in...

Specify the id of the element, a DOM element or an existing Element corresponding to a DIV that is already present in the document that specifies some structural markup for this component.

- Description :
  When `applyTo` is used, constituent parts of the component can also be specified by id or CSS class name within the main element, and the component being created may attempt to create its subcomponents from that markup if applicable.
- Notes :
  When using this config, a call to render() is not required.
  If applyTo is specified, any value passed for renderTo will be ignored and the target element's parent node will automatically be used as the component's container.

Component

autoEl : Mixed
A tag name or DomHelper spec used to create the Element which will encapsulate this Component. You do not normally ne...

A tag name or DomHelper spec used to create the Element which will encapsulate this Component.

You do not normally need to specify this. For the base classes Ext.Component, Ext.BoxComponent, and Ext.Container, this defaults to `'div'`. The more complex Ext classes use a more complex DOM structure created by their own onRender methods.

This is intended to allow the developer to create application-specific utility Components encapsulated by different DOM elements. Example usage:

    {
        xtype: 'box',
        autoEl: {
            tag: 'img',
            src: 'http://www.example.com/example.jpg'
        }
    }, {
        xtype: 'box',
        autoEl: {
            tag: 'blockquote',
            html: 'autoEl is cool!'
        }
    }, {
        xtype: 'container',
        autoEl: 'ul',
        cls: 'ux-unordered-list',
        items: {
            xtype: 'box',
            autoEl: 'li',
            html: 'First list item'
        }
    }

Component

| autoShow : Boolean True if the component should check for hidden classes (e.g. 'x-hidden' or 'x-hide-display') and remove them on render... True if the component should check for hidden classes (e.g. 'x-hidden' or 'x-hide-display') and remove them on render (defaults to false). | Component
| autoSize : Boolean/String True for the editor to automatically adopt the size of the underlying field, "width" to adopt the width only, or "hei... True for the editor to automatically adopt the size of the underlying field, "width" to adopt the width only, or "height" to adopt the height only, "none" to always use the field dimensions. (defaults to false) | Editor
| bubbleEvents : Array An array of events that, when fired, should be bubbled to any parent container. See Ext.util.Observable.enableBubble.... An array of events that, when fired, should be bubbled to any parent container. See Ext.util.Observable.enableBubble. Defaults to `[]`. | Component
| cancelOnEsc : Boolean True to cancel the edit when the escape key is pressed. Defaults to `true`. | Editor

clearCls : String
The CSS class used to to apply to the special clearing div rendered directly after each form field wrapper to provide...

The CSS class used to to apply to the special clearing div rendered directly after each form field wrapper to provide field clearing (defaults to `'x-form-clear-left'`).

Note: this config is only used when this Component is rendered by a Container which has been configured to use the FormLayout layout manager (e.g. Ext.form.FormPanel or specifying `layout:'form'`) and either a `fieldLabel` is specified or `isFormField=true` is specified.

See Ext.layout.FormLayout.fieldTpl also.

Component

| cls : String CSS class to apply to the editor (defaults to "x-small-editor x-tree-editor") | TreeEditor
| completeOnEnter : Boolean True to complete the edit when the enter key is pressed. Defaults to `true`. | Editor
| constrain : Boolean True to constrain the editor to the viewport | Editor

contentEl : String
Optional. Specify an existing HTML element, or the id of an existing HTML element to use as the content for this comp...

Optional. Specify an existing HTML element, or the `id` of an existing HTML element to use as the content for this component.

- Description :
  This config option is used to take an existing HTML element and place it in the layout element of a new component (it simply moves the specified DOM element after the Component is rendered to use as the content.
- Notes :
  The specified HTML element is appended to the layout element of the component after any configured HTML has been inserted, and so the document will not contain this element at the time the render event is fired.
  The specified HTML element used will not participate in any `layout` scheme that the Component may use. It is just HTML. Layouts operate on child `items`.
  Add either the `x-hidden` or the `x-hide-display` CSS class to prevent a brief flicker of the content before it is rendered to the panel.

Component

ctCls : String
An optional extra CSS class that will be added to this component's container. This can be useful for adding customize...

An optional extra CSS class that will be added to this component's container. This can be useful for adding customized styles to the container or any of its children using standard CSS rules. See Ext.layout.ContainerLayout.extraCls also.

Note: `ctCls` defaults to `''` except for the following class which assigns a value by default:

- Box Layout : `'x-box-layout-ct'`

To configure the above Class with an extra CSS class append to the default. For example, for BoxLayout (Hbox and Vbox):

    ctCls: 'x-box-layout-ct custom-class'

Component

| data : Mixed The initial set of data to apply to the `tpl` to update the content area of the Component. | Component
| disabled : Boolean Render this component disabled (default is false). | Component
| disabledClass : String CSS class added to the component when it is disabled (defaults to 'x-item-disabled'). | Component

editDelay : Number
The number of milliseconds between clicks to register a double-click that will trigger editing on the current node (d...
The number of milliseconds between clicks to register a double-click that will trigger editing on the current node (defaults to 350). If two clicks occur on the same node within this time span, the editor for the node will display, otherwise it will be processed as a regular click.

TreeEditor

| field : Ext.form.Field The Field object (or descendant) or config object for field | Editor

fieldLabel : String
The label text to display next to this Component (defaults to ''). Note: this config is only used when this Component...

The label text to display next to this Component (defaults to '').

Note: this config is only used when this Component is rendered by a Container which has been configured to use the FormLayout layout manager (e.g. Ext.form.FormPanel or specifying `layout:'form'`).

Also see `hideLabel` and Ext.layout.FormLayout.fieldTpl.

Example use:

    new Ext.FormPanel({
        height: 100,
        renderTo: Ext.getBody(),
        items: [{
            xtype: 'textfield',
            fieldLabel: 'Name'
        }]
    });

Component

| hidden : Boolean Render this component hidden (default is false). If `true`, the hide method will be called internally. | Component
| hideEl : Boolean True to hide the bound element while the editor is displayed (defaults to false) | TreeEditor

hideLabel : Boolean
true to completely hide the label element (label and separator). Defaults to false. By default, even if you do not sp...

`true` to completely hide the label element (label and separator). Defaults to `false`. By default, even if you do not specify a `fieldLabel` the space will still be reserved so that the field will line up with other fields that do have labels. Setting this to `true` will cause the field to not reserve that space.

Note: see the note for `clearCls`.

Example use:

    new Ext.FormPanel({
        height: 100,
        renderTo: Ext.getBody(),
        items: [{
            xtype: 'textfield'
            hideLabel: true
        }]
    });

Component

hideMode : String
How this component should be hidden. Supported values are 'visibility' (css visibility), 'offsets' (negative offset p...

How this component should be hidden. Supported values are `'visibility'` (css visibility), `'offsets'` (negative offset position) and `'display'` (css display).

Note: the default of `'display'` is generally preferred since items are automatically laid out when they are first shown (no sizing is done while hidden).

Component

hideParent : Boolean
True to hide and show the component's container when hide/show is called on the component, false to hide and show the...
True to hide and show the component's container when hide/show is called on the component, false to hide and show the component itself (defaults to false). For example, this can be used as a shortcut for a hide button on a window by setting hide:true on the button when adding it to its parent container.

Component

html : String/Object
An HTML fragment, or a DomHelper specification to use as the layout element content (defaults to ''). The HTML conten...
An HTML fragment, or a DomHelper specification to use as the layout element content (defaults to ''). The HTML content is added after the component is rendered, so the document will not contain this HTML at the time the render event is fired. This content is inserted into the body before any configured contentEl is appended.

Component

id : String
The unique id of this component (defaults to an auto-assigned id). You should assign an id if you need to be able to ...

The unique id of this component (defaults to an auto-assigned id). You should assign an id if you need to be able to access the component later and you do not have an object reference available (e.g., using Ext.getCmp).

Note that this id will also be used as the element id for the containing HTML element that is rendered to the page for this component. This allows you to write id-based CSS rules to style the specific instance of this component uniquely, and also to select sub-elements using this component's id as the parent.

Note: to avoid complications imposed by a unique `id` also see `itemId` and `ref`.

Note: to access the container of an item see `ownerCt`.

Component

| ignoreNoChange : Boolean True to skip the edit completion process (no save, no events fired) if the user completes an edit and the value has n... True to skip the edit completion process (no save, no events fired) if the user completes an edit and the value has not changed (defaults to false). Applies only to string values - edits for other data types will never be ignored. | Editor

itemCls : String
Note: this config is only used when this Component is rendered by a Container which has been configured to use the Fo...

Note: this config is only used when this Component is rendered by a Container which has been configured to use the FormLayout layout manager (e.g. Ext.form.FormPanel or specifying `layout:'form'`).

An additional CSS class to apply to the div wrapping the form item element of this field. If supplied, `itemCls` at the field level will override the default `itemCls` supplied at the container level. The value specified for `itemCls` will be added to the default class (`'x-form-item'`).

Since it is applied to the item wrapper (see Ext.layout.FormLayout.fieldTpl), it allows you to write standard CSS rules that can apply to the field, the label (if specified), or any other element within the markup for the field.

Note: see the note for `fieldLabel`.

Example use:

    // Apply a style to the field's label:
    <style>
        .required .x-form-item-label {font-weight:bold;color:red;}
    </style>

    new Ext.FormPanel({
        height: 100,
        renderTo: Ext.getBody(),
        items: [{
            xtype: 'textfield',
            fieldLabel: 'Name',
            itemCls: 'required' //this label will be styled
        },{
            xtype: 'textfield',
            fieldLabel: 'Favorite Color'
        }]
    });

Component

itemId : String
An itemId can be used as an alternative way to get a reference to a component when no object reference is available. ...

An `itemId` can be used as an alternative way to get a reference to a component when no object reference is available. Instead of using an `id` with Ext.getCmp, use `itemId` with Ext.Container.getComponent which will retrieve `itemId`'s or `id`'s. Since `itemId`'s are an index to the container's internal MixedCollection, the `itemId` is scoped locally to the container -- avoiding potential conflicts with Ext.ComponentMgr which requires a unique `id`.

    var c = new Ext.Panel({ //
        height: 300,
        renderTo: document.body,
        layout: 'auto',
        items: [
            {
                itemId: 'p1',
                title: 'Panel 1',
                height: 150
            },
            {
                itemId: 'p2',
                title: 'Panel 2',
                height: 150
            }
        ]
    })
    p1 = c.getComponent('p1'); // not the same as Ext.getCmp()
    p2 = p1.ownerCt.getComponent('p2'); // reference via a sibling

Also see `id` and `ref`.

Note: to access the container of an item see `ownerCt`.

Component

labelSeparator : String
The separator to display after the text of each fieldLabel. This property may be configured at various levels. The o...

The separator to display after the text of each `fieldLabel`. This property may be configured at various levels. The order of precedence is:

- field / component level
- container level
- layout level (defaults to colon `':'`)

To display no separator for this field's label specify empty string ''.

Note: see the note for `clearCls`.

Also see `hideLabel` and Ext.layout.FormLayout.fieldTpl.

Example use:

    new Ext.FormPanel({
        height: 100,
        renderTo: Ext.getBody(),
        layoutConfig: {
            labelSeparator: '~'   // layout config has lowest priority (defaults to ':')
        },
        labelSeparator: '>>',     // config at container level
        items: [{
            xtype: 'textfield',
            fieldLabel: 'Field 1',
            labelSeparator: '...' // field/component level config supersedes others
        },{
            xtype: 'textfield',
            fieldLabel: 'Field 2' // labelSeparator will be '='
        }]
    });

Component

labelStyle : String
A CSS style specification string to apply directly to this field's label. Defaults to the container's labelStyle val...

A CSS style specification string to apply directly to this field's label. Defaults to the container's labelStyle value if set (e.g., `Ext.layout.FormLayout.labelStyle` , or '').

Note: see the note for `clearCls`.

Also see `hideLabel` and `Ext.layout.FormLayout.fieldTpl.`

Example use:

    new Ext.FormPanel({
        height: 100,
        renderTo: Ext.getBody(),
        items: [{
            xtype: 'textfield',
            fieldLabel: 'Name',
            labelStyle: 'font-weight:bold;'
        }]
    });

Component

listeners : Object
A config object containing one or more event handlers to be added to this object during initialization. This should ...

A config object containing one or more event handlers to be added to this object during initialization. This should be a valid listeners config object as specified in the addListener example for attaching multiple handlers at once.

DOM events from ExtJs Components

While some ExtJs Component classes export selected DOM events (e.g. "click", "mouseover" etc), this is usually only done when extra value can be added. For example the DataView's `click` event passing the node clicked on. To access DOM events directly from a Component's HTMLElement, listeners must be added to the Element after the Component has been rendered. A plugin can simplify this step:

    // Plugin is configured with a listeners config object.
    // The Component is appended to the argument list of all handler functions.
    Ext.DomObserver = Ext.extend(Object, {
        constructor: function(config) {
            this.listeners = config.listeners ? config.listeners : config;
        },

        // Component passes itself into plugin's init method
        init: function(c) {
            var p, l = this.listeners;
            for (p in l) {
                if (Ext.isFunction(l[p])) {
                    l[p] = this.createHandler(l[p], c);
                } else {
                    l[p].fn = this.createHandler(l[p].fn, c);
                }
            }

            // Add the listeners to the Element immediately following the render call
            c.render = c.render.createSequence(function() {
                var e = c.getEl();
                if (e) {
                    e.on(l);
                }
            });
        },

        createHandler: function(fn, c) {
            return function(e) {
                fn.call(this, e, c);
            };
        }
    });

    var combo = new Ext.form.ComboBox({

        // Collapse combo when its element is clicked on
        plugins: [ new Ext.DomObserver({
            click: function(evt, comp) {
                comp.collapse();
            }
        })],
        store: myStore,
        typeAhead: true,
        mode: 'local',
        triggerAction: 'all'
    });

Observable

maxWidth : Number
The maximum width in pixels of the editor field (defaults to 250). Note that if the maxWidth would exceed the contai...
The maximum width in pixels of the editor field (defaults to 250). Note that if the maxWidth would exceed the containing tree element's size, it will be automatically limited for you to the container width, taking scroll and client offsets into account prior to each edit.

TreeEditor

| offsets : Array The offsets to use when aligning (see Ext.Element.alignTo for more details. Defaults to `[0, 0]`. | Editor

overCls : String
An optional extra CSS class that will be added to this component's Element when the mouse moves over the Element, and...
An optional extra CSS class that will be added to this component's Element when the mouse moves over the Element, and removed when the mouse moves out. (defaults to ''). This can be useful for adding customized 'active' or 'hover' styles to the component or any of its children using standard CSS rules.

Component

plugins : Object/Array
An object or array of objects that will provide custom functionality for this component. The only requirement for a ...
An object or array of objects that will provide custom functionality for this component. The only requirement for a valid plugin is that it contain an init method that accepts a reference of type Ext.Component. When a component is created, if any plugins are available, the component will call the init method on each plugin, passing a reference to itself. Each plugin can then call methods or respond to events on the component as needed to provide its functionality.

Component

ptype : String
The registered ptype to create. This config option is not used when passing a config object into a constructor. This ...
The registered `ptype` to create. This config option is not used when passing a config object into a constructor. This config option is used only when lazy instantiation is being used, and a Plugin is being specified not as a fully instantiated Component, but as a Component config object. The `ptype` will be looked up at render time up to determine what type of Plugin to create.
If you create your own Plugins, you may register them using Ext.ComponentMgr.registerPlugin in order to be able to take advantage of lazy instantiation and rendering.

Component

ref : String
A path specification, relative to the Component's ownerCt specifying into which ancestor Container to place a named r...

A path specification, relative to the Component's `ownerCt` specifying into which ancestor Container to place a named reference to this Component.

The ancestor axis can be traversed by using '/' characters in the path. For example, to put a reference to a Toolbar Button into the Panel which owns the Toolbar:

    var myGrid = new Ext.grid.EditorGridPanel({
        title: 'My EditorGridPanel',
        store: myStore,
        colModel: myColModel,
        tbar: [{
            text: 'Save',
            handler: saveChanges,
            disabled: true,
            ref: '../saveButton'
        }],
        listeners: {
            afteredit: function() {
    //          The button reference is in the GridPanel
                myGrid.saveButton.enable();
            }
        }
    });

In the code above, if the `ref` had been `'saveButton'` the reference would have been placed into the Toolbar. Each '/' in the `ref` moves up one level from the Component's `ownerCt`.

Also see the `added` and `removed` events.

Component

renderTo : Mixed
Specify the id of the element, a DOM element or an existing Element that this component will be rendered into. Notes ...

Specify the id of the element, a DOM element or an existing Element that this component will be rendered into.

- Notes :
  Do not use this option if the Component is to be a child item of a Container. It is the responsibility of the Container's layout manager to render and manage its child items.
  When using this config, a call to render() is not required.

See `render` also.

Component

| revertInvalid : Boolean True to automatically revert the field value and cancel the edit when the user completes an edit and the field valida... True to automatically revert the field value and cancel the edit when the user completes an edit and the field validation fails (defaults to true) | Editor
| shadow : Boolean/String "sides" for sides/bottom only, "frame" for 4-way shadow, and "drop" for bottom-right shadow (defaults to "frame") | Editor
| shim : Boolean True to shim the editor if selects/iframes could be displayed beneath it (defaults to false) | TreeEditor

stateEvents : Array
An array of events that, when fired, should trigger this component to save its state (defaults to none). stateEvents ...

An array of events that, when fired, should trigger this component to save its state (defaults to none). `stateEvents` may be any type of event supported by this component, including browser or custom events (e.g., `['click', 'customerchange']`).

See `stateful` for an explanation of saving and restoring Component state.

Component

| stateId : String The unique id for this component to use for state management purposes (defaults to the component id if one was set, o... The unique id for this component to use for state management purposes (defaults to the component id if one was set, otherwise null if the component is using a generated id). See `stateful` for an explanation of saving and restoring Component state. | Component

stateful : Boolean
A flag which causes the Component to attempt to restore the state of internal properties from a saved state on startu...

A flag which causes the Component to attempt to restore the state of internal properties from a saved state on startup. The component must have either a `stateId` or `id` assigned for state to be managed. Auto-generated ids are not guaranteed to be stable across page loads and cannot be relied upon to save and restore the same state for a component.

For state saving to work, the state manager's provider must have been set to an implementation of Ext.state.Provider which overrides the set and get methods to save and recall name/value pairs. A built-in implementation, Ext.state.CookieProvider is available.

To set the state provider for the current page:

    Ext.state.Manager.setProvider(new Ext.state.CookieProvider({
        expires: new Date(new Date().getTime()+(1000*60*60*24*7)), //7 days from now
    }));

A stateful Component attempts to save state when one of the events listed in the `stateEvents` configuration fires.

To save state, a stateful Component first serializes its state by calling `getState`. By default, this function does nothing. The developer must provide an implementation which returns an object hash which represents the Component's restorable state.

The value yielded by getState is passed to Ext.state.Manager.set which uses the configured Ext.state.Provider to save the object keyed by the Component's `stateId`, or, if that is not specified, its `id`.

During construction, a stateful Component attempts to restore its state by calling Ext.state.Manager.get passing the `stateId`, or, if that is not specified, the `id`.

The resulting object is passed to `applyState`. The default implementation of `applyState` simply copies properties into the object, but a developer may override this to support more behaviour.

You can perform extra processing on state save and restore by attaching handlers to the beforestaterestore, staterestore, beforestatesave and statesave events.

Component

style : String
A custom style specification to be applied to this component's Element. Should be a valid argument to Ext.Element.ap...
A custom style specification to be applied to this component's Element. Should be a valid argument to Ext.Element.applyStyles.

    new Ext.Panel({
        title: 'Some Title',
        renderTo: Ext.getBody(),
        width: 400, height: 300,
        layout: 'form',
        items: [{
            xtype: 'textarea',
            style: {
                width: '95%',
                marginBottom: '10px'
            }
        },
            new Ext.Button({
                text: 'Send',
                minWidth: '100',
                style: {
                    marginBottom: '10px'
                }
            })
        ]
    });

Component

| swallowKeys : Boolean Handle the keydown/keypress events so they don't propagate (defaults to true) | Editor
| tpl : Mixed An Ext.Template, Ext.XTemplate or an array of strings to form an Ext.XTemplate. Used in conjunction with the data and... An <bold>Ext.Template</bold>, <bold>Ext.XTemplate</bold> or an array of strings to form an Ext.XTemplate. Used in conjunction with the `data` and `tplWriteMode` configurations. | Component
| tplWriteMode : String The Ext.(X)Template method to use when updating the content area of the Component. Defaults to 'overwrite' (see Ext.X... The Ext.(X)Template method to use when updating the content area of the Component. Defaults to `'overwrite'` (see `Ext.XTemplate.overwrite`). | Component
| updateEl : Boolean True to update the innerHTML of the bound element when the update completes (defaults to false) | Editor
| value : Mixed The data value of the underlying field (defaults to "") | Editor

xtype : String
The registered xtype to create. This config option is not used when passing a config object into a constructor. This ...
The registered `xtype` to create. This config option is not used when passing a config object into a constructor. This config option is used only when lazy instantiation is being used, and a child item of a Container is being specified not as a fully instantiated Component, but as a Component config object. The `xtype` will be looked up at render time up to determine what type of child Component to create.
The predefined xtypes are listed here.
If you subclass Components to create your own Components, you may register them using Ext.ComponentMgr.registerType in order to be able to take advantage of lazy instantiation and rendering.

Component

## Public Properties

Property | Defined By
--- | ---
| disabled : Boolean True if this component is disabled. Read-only. | Component
| editNode : Ext.tree.TreeNode The TreeNode this editor is bound to. Read-only. | TreeEditor

el : Ext.Element
The Ext.Element which encapsulates this Component. Read-only. This will usually be a &lt;DIV> element created by the ...

The Ext.Element which encapsulates this Component. Read-only.

This will usually be a <DIV> element created by the class's onRender method, but that may be overridden using the `autoEl` config.

Note: this element will not be available until this Component has been rendered.

To add listeners for DOM events to this Component (as opposed to listeners for this Component's own Observable events), see the listeners config for a suggestion, or use a render listener directly:

    new Ext.Panel({
        title: 'The Clickable Panel',
        listeners: {
            render: function(p) {
                // Append the Panel to the click handler's argument list.
                p.getEl().on('click', handlePanelClick.createDelegate(null, [p], true));
            },
            single: true  // Remove the listener after first invocation
        }
    });

See also `getEl`

Component

| hidden : Boolean True if this component is hidden. Read-only. | Component
| initialConfig : Object This Component's initial configuration specification. Read-only. | Component
| ownerCt : Ext.Container This Component's owner Container (defaults to undefined, and is set automatically when this Component is added to a C... This Component's owner Container (defaults to undefined, and is set automatically when this Component is added to a Container). Read-only. Note: to access items within the Container see `itemId`. | Component
| refOwner : Ext.Container The ancestor Container into which the ref reference was inserted if this Component is a child of a Container, and has... The ancestor Container into which the ref reference was inserted if this Component is a child of a Container, and has been configured with a `ref`. | Component
| rendered : Boolean True if this component has been rendered. Read-only. | Component

## Public Methods

Method | Defined By
--- | ---

TreeEditor( `TreePanel tree`, [`Object fieldConfig`], [`Object config`] )
Parameters:

- `tree` : TreePanel
- `fieldConfig` : Object
  (optional) Either a prebuilt Ext.form.Field instance or a Field config object that will be applied to the default field instance (defaults to a Ext.form.TextField).
- `config` : Object
  (optional) A TreeEditor config object

Returns:

- void

TreeEditor

addClass( `string cls` ) : Ext.Component
Adds a CSS class to the component's underlying element.
Adds a CSS class to the component's underlying element.
Parameters:

- `cls` : string
  The CSS class name to add

Returns:

- `Ext.Component`
  this

Component

addEvents( `Object|String o`, `string Optional.` ) : void
Adds the specified events to the list of events which this Observable may fire.
Adds the specified events to the list of events which this Observable may fire.
Parameters:

- `o` : Object|String
  Either an object with event names as properties with a value of `true` or the first event name string if multiple event names are being passed as separate parameters.
- `Optional.` : string
  Event name if multiple event names are being passed as separate parameters. Usage:

      this.addEvents('storeloaded', 'storecleared');

Returns:

- void

Observable

addListener( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this object.
Appends an event handler to this object.
Parameters:

- `eventName` : String
  The name of the event to listen for.
- `handler` : Function
  The method the event invokes.
- `scope` : Object
  (optional) The scope (`this` reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.
- `options` : Object
  (optional) An object containing handler configuration. properties. This may contain any of the following properties:
  - scope : Object
    The scope (`this` reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.
  - delay : Number
    The number of milliseconds to delay the invocation of the handler after the event fires.
  - single : Boolean
    True to add a handler to handle just the next firing of the event, and then remove itself.
  - buffer : Number
    Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.
  - target : Observable
    Only call the handler if the event was fired on the target Observable, not if the event was bubbled up from a child Observable.

  Combining Options
  Using the options argument, it is possible to combine different types of listeners:
  A delayed, one-time listener.

      myDataView.on('click', this.onClick, this, {
      single: true,
      delay: 100
      });

  Attaching multiple handlers in 1 call
  The method also allows for a single argument to be passed which is a config object containing properties which specify multiple handlers.

      myGridPanel.on({
      'click' : {
          fn: this.onClick,
          scope: this,
          delay: 100
      },
      'mouseover' : {
          fn: this.onMouseOver,
          scope: this
      },
      'mouseout' : {
          fn: this.onMouseOut,
          scope: this
      }
      });

  Or a shorthand syntax:

      myGridPanel.on({
      'click' : this.onClick,
      'mouseover' : this.onMouseOver,
      'mouseout' : this.onMouseOut,
       scope: this
      });

Returns:

- void

Observable

applyToMarkup( `String/HTMLElement el` ) : void
Apply this component to existing markup that is valid. With this function, no call to render() is required.
Apply this component to existing markup that is valid. With this function, no call to render() is required.
Parameters:

- `el` : String/HTMLElement

Returns:

- void

Component

bubble( `Function fn`, [`Object scope`], [`Array args`] ) : Ext.Component
Bubbles up the component/container heirarchy, calling the specified function with each component. The scope (this) of...
Bubbles up the component/container heirarchy, calling the specified function with each component. The scope (this) of function call will be the scope provided or the current component. The arguments to the function will be the args provided or the current component. If the function returns false at any point, the bubble is stopped.
Parameters:

- `fn` : Function
  The function to call
- `scope` : Object
  (optional) The scope of the function (defaults to current node)
- `args` : Array
  (optional) The args to call the function with (default to passing the current component)

Returns:

- `Ext.Component`
  this

Component

cancelEdit( `Boolean remainVisible` ) : void
Cancels the editing process and hides the editor without persisting any changes. The field value will be reverted to...
Cancels the editing process and hides the editor without persisting any changes. The field value will be reverted to the original starting value.
Parameters:

- `remainVisible` : Boolean
  Override the default behavior and keep the editor visible after cancel (defaults to false)

Returns:

- void

Editor

cloneConfig( `Object overrides` ) : Ext.Component
Clone the current component using the original config values passed into this instance by default.
Clone the current component using the original config values passed into this instance by default.
Parameters:

- `overrides` : Object
  A new config containing any properties to override in the cloned version. An id property can be passed on this object, otherwise one will be generated to avoid duplicates.

Returns:

- `Ext.Component`
  clone The cloned copy of this component

Component

completeEdit( `Boolean remainVisible` ) : void
Ends the editing process, persists the changed value to the underlying field, and hides the editor.
Ends the editing process, persists the changed value to the underlying field, and hides the editor.
Parameters:

- `remainVisible` : Boolean
  Override the default behavior and keep the editor visible after edit (defaults to false)

Returns:

- void

Editor

destroy() : void
Destroys this component by purging any event listeners, removing the component's element from the DOM, removing the c...
Destroys this component by purging any event listeners, removing the component's element from the DOM, removing the component from its Ext.Container (if applicable) and unregistering it from Ext.ComponentMgr. Destruction is generally handled automatically by the framework and this method should usually not need to be called directly.
Parameters:

- None.

Returns:

- void

Component

disable() : Ext.Component
Disable this component and fire the 'disable' event.
Disable this component and fire the 'disable' event.
Parameters:

- None.

Returns:

- `Ext.Component`
  this

Component

enable() : Ext.Component
Enable this component and fire the 'enable' event.
Enable this component and fire the 'enable' event.
Parameters:

- None.

Returns:

- `Ext.Component`
  this

Component

enableBubble( `String/Array events` ) : void
Enables events fired by this Observable to bubble up an owner hierarchy by calling this.getBubbleTarget() if present....

Enables events fired by this Observable to bubble up an owner hierarchy by calling `this.getBubbleTarget()` if present. There is no implementation in the Observable base class.

This is commonly used by Ext.Components to bubble events to owner Containers. See Ext.Component.getBubbleTarget. The default implementation in Ext.Component returns the Component's immediate owner. But if a known target is required, this can be overridden to access the required target more quickly.

Example:

    Ext.override(Ext.form.Field, {
        //  Add functionality to Field's initComponent to enable the change event to bubble
        initComponent : Ext.form.Field.prototype.initComponent.createSequence(function() {
            this.enableBubble('change');
        }),

        //  We know that we want Field's events to bubble directly to the FormPanel.
        getBubbleTarget : function() {
            if (!this.formPanel) {
                this.formPanel = this.findParentByType('form');
            }
            return this.formPanel;
        }
    });

    var myForm = new Ext.formPanel({
        title: 'User Details',
        items: [{
            ...
        }],
        listeners: {
            change: function() {
                // Title goes red if form has been modified.
                myForm.header.setStyle('color', 'red');
            }
        }
    });

Parameters:

- `events` : String/Array
  The event name to bubble, or an Array of event names.

Returns:

- void

Observable

findParentBy( `Function fn` ) : Ext.Container
Find a container above this component at any level by a custom function. If the passed function returns true, the con...
Find a container above this component at any level by a custom function. If the passed function returns true, the container will be returned.
Parameters:

- `fn` : Function
  The custom function to call with the arguments (container, this component).

Returns:

- `Ext.Container`
  The first Container for which the custom function returns true

Component

findParentByType( `String/Ext.Component/Class xtype`, [`Boolean shallow`] ) : Ext.Container
Find a container above this component at any level by xtype or class
Find a container above this component at any level by xtype or class
Parameters:

- `xtype` : String/Ext.Component/Class
  The xtype to check for this Component. Note that the the component can either be an instance or a component class:
- `shallow` : Boolean
  (optional) False to check whether this Component is descended from the xtype (this is the default), or true to check whether this Component is directly of the specified xtype.

Returns:

- `Ext.Container`
  The first Container which matches the given xtype or class

Component

fireEvent( `String eventName`, `Object... args` ) : Boolean
Fires the specified event with the passed parameters (minus the event name). An event may be set to bubble up an Obse...

Fires the specified event with the passed parameters (minus the event name).

An event may be set to bubble up an Observable parent hierarchy (See Ext.Component.getBubbleTarget) by calling enableBubble.

Parameters:

- `eventName` : String
  The name of the event to fire.
- `args` : Object...
  Variable number of parameters are passed to handlers.

Returns:

- `Boolean`
  returns false if any of the handlers return false otherwise it returns true.

Observable

focus( [`Boolean selectText`], [`Boolean/Number delay`] ) : Ext.Component
Try to focus this component.
Try to focus this component.
Parameters:

- `selectText` : Boolean
  (optional) If applicable, true to also select the text in this component
- `delay` : Boolean/Number
  (optional) Delay the focus this number of milliseconds (true for 10 milliseconds)

Returns:

- `Ext.Component`
  this

Component

getBubbleTarget() : Ext.Container
Provides the link for Observable's fireEvent method to bubble up the ownership hierarchy.
Provides the link for Observable's fireEvent method to bubble up the ownership hierarchy.
Parameters:

- None.

Returns:

- `Ext.Container`
  the Container which owns this Component.

Component

getEl() : Ext.Element
Returns the Ext.Element which encapsulates this Component. This will usually be a &lt;DIV> element created by the cla...

Returns the Ext.Element which encapsulates this Component.

This will usually be a <DIV> element created by the class's onRender method, but that may be overridden using the autoEl config.

Note: this element will not be available until this Component has been rendered.

To add listeners for DOM events to this Component (as opposed to listeners for this Component's own Observable events), see the listeners config for a suggestion, or use a render listener directly:

    new Ext.Panel({
        title: 'The Clickable Panel',
        listeners: {
            render: function(p) {
                // Append the Panel to the click handler's argument list.
                p.getEl().on('click', handlePanelClick.createDelegate(null, [p], true));
            },
            single: true  // Remove the listener after first invocation
        }
    });

Parameters:

- None.

Returns:

- `Ext.Element`
  The Element which encapsulates this Component.

Component

getId() : String
Returns the id of this component or automatically generates and returns an id if an id is not defined yet:'ext-comp-'...
Returns the `id` of this component or automatically generates and returns an `id` if an `id` is not defined yet:

    'ext-comp-' + (++Ext.Component.AUTO_ID)

Parameters:

- None.

Returns:

- `String`
  id

Component

getItemId() : String
Returns the itemId of this component. If an itemId was not assigned through configuration the id is returned using g...
Returns the `itemId` of this component. If an `itemId` was not assigned through configuration the `id` is returned using `getId`.
Parameters:

- None.

Returns:

- `String`

Component

getValue() : Mixed
Gets the data value of the editor
Gets the data value of the editor
Parameters:

- None.

Returns:

- `Mixed`
  The data value

Editor

getXType() : String
Gets the xtype for this component as registered with Ext.ComponentMgr. For a list of all available xtypes, see the Ex...
Gets the xtype for this component as registered with Ext.ComponentMgr. For a list of all available xtypes, see the Ext.Component header. Example usage:

    var t = new Ext.form.TextField();
    alert(t.getXType());  // alerts 'textfield'

Parameters:

- None.

Returns:

- `String`
  The xtype

Component

getXTypes() : String
Returns this Component's xtype hierarchy as a slash-delimited string. For a list of all available xtypes, see the Ext...

Returns this Component's xtype hierarchy as a slash-delimited string. For a list of all available xtypes, see the Ext.Component header.

If using your own subclasses, be aware that a Component must register its own xtype to participate in determination of inherited xtypes.

Example usage:

    var t = new Ext.form.TextField();
    alert(t.getXTypes());  // alerts 'component/box/field/textfield'

Parameters:

- None.

Returns:

- `String`
  The xtype hierarchy string

Component

hasListener( `String eventName` ) : Boolean
Checks to see if this object has any listeners for a specified event
Checks to see if this object has any listeners for a specified event
Parameters:

- `eventName` : String
  The name of the event to check for

Returns:

- `Boolean`
  True if the event is being listened for, else false

Observable

hide() : Ext.Component
Hide this component. Listen to the 'beforehide' event and return false to cancel hiding the component. Fires the 'h...
Hide this component. Listen to the 'beforehide' event and return `false` to cancel hiding the component. Fires the 'hide' event after hiding the component. Note this method is called internally if the component is configured to be `hidden`.
Parameters:

- None.

Returns:

- `Ext.Component`
  this

Component

isVisible() : Boolean
Returns true if this component is visible.
Returns true if this component is visible.
Parameters:

- None.

Returns:

- `Boolean`
  True if this component is visible, false otherwise.

Component

isXType( `String/Ext.Component/Class xtype`, [`Boolean shallow`] ) : Boolean
Tests whether or not this Component is of a specific xtype. This can test whether this Component is descended from th...

Tests whether or not this Component is of a specific xtype. This can test whether this Component is descended from the xtype (default) or whether it is directly of the xtype specified (shallow = true).

If using your own subclasses, be aware that a Component must register its own xtype to participate in determination of inherited xtypes.

For a list of all available xtypes, see the Ext.Component header.

Example usage:

    var t = new Ext.form.TextField();
    var isText = t.isXType('textfield');        // true
    var isBoxSubclass = t.isXType('box');       // true, descended from BoxComponent
    var isBoxInstance = t.isXType('box', true); // false, not a direct BoxComponent instance

Parameters:

- `xtype` : String/Ext.Component/Class
  The xtype to check for this Component. Note that the the component can either be an instance or a component class:

      var c = new Ext.Component();
      console.log(c.isXType(c));
      console.log(c.isXType(Ext.Component));

- `shallow` : Boolean
  (optional) False to check whether this Component is descended from the xtype (this is the default), or true to check whether this Component is directly of the specified xtype.

Returns:

- `Boolean`
  True if this component descends from the specified xtype, false otherwise.

Component

mon( `Observable|Element item`, `Object|String ename`, `Function fn`, `Object scope`, `Object opt` ) : void
Adds listeners to any Observable object (or Elements) which are automatically removed when this Component is destroye...

Adds listeners to any Observable object (or Elements) which are automatically removed when this Component is destroyed. Usage:

`

    myGridPanel.mon(myGridPanel.getSelectionModel(), 'selectionchange', handleSelectionChange, null, {buffer: 50});

`

or:

`

    myGridPanel.mon(myGridPanel.getSelectionModel(), {
        selectionchange: handleSelectionChange,
        buffer: 50
    });

`
Parameters:

- `item` : Observable|Element
  The item to which to add a listener/listeners.
- `ename` : Object|String
  The event name, or an object containing event name properties.
- `fn` : Function
  Optional. If the `ename` parameter was an event name, this is the handler function.
- `scope` : Object
  Optional. If the `ename` parameter was an event name, this is the scope (`this` reference) in which the handler function is executed.
- `opt` : Object
  Optional. If the `ename` parameter was an event name, this is the addListener options.

Returns:

- void

Component

mun( `Observable|Element item`, `Object|String ename`, `Function fn`, `Object scope` ) : void
Removes listeners that were added by the mon method.
Removes listeners that were added by the mon method.
Parameters:

- `item` : Observable|Element
  The item from which to remove a listener/listeners.
- `ename` : Object|String
  The event name, or an object containing event name properties.
- `fn` : Function
  Optional. If the `ename` parameter was an event name, this is the handler function.
- `scope` : Object
  Optional. If the `ename` parameter was an event name, this is the scope (`this` reference) in which the handler function is executed.

Returns:

- void

Component

nextSibling() : Ext.Component
Returns the next component in the owning container
Returns the next component in the owning container
Parameters:

- None.

Returns:

- `Ext.Component`

Component

on( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this object (shorthand for addListener.)
Appends an event handler to this object (shorthand for addListener.)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `scope` : Object
  (optional) The scope (`this` reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.
- `options` : Object
  (optional) An object containing handler configuration.

Returns:

- void

Observable

previousSibling() : Ext.Component
Returns the previous component in the owning container
Returns the previous component in the owning container
Parameters:

- None.

Returns:

- `Ext.Component`

Component

purgeListeners() : void
Removes all listeners for this object
Removes all listeners for this object
Parameters:

- None.

Returns:

- void

Observable

realign( [`Boolean autoSize`] ) : void
Realigns the editor to the bound field based on the current alignment config value.
Realigns the editor to the bound field based on the current alignment config value.
Parameters:

- `autoSize` : Boolean
  (optional) True to size the field to the dimensions of the bound element.

Returns:

- void

Editor

relayEvents( `Object o`, `Array events` ) : void
Relays selected events from the specified Observable as if the events were fired by this.
Relays selected events from the specified Observable as if the events were fired by `this`.
Parameters:

- `o` : Object
  The Observable whose events this object is to relay.
- `events` : Array
  Array of event names to relay.

Returns:

- void

Observable

removeClass( `string cls` ) : Ext.Component
Removes a CSS class from the component's underlying element.
Removes a CSS class from the component's underlying element.
Parameters:

- `cls` : string
  The CSS class name to remove

Returns:

- `Ext.Component`
  this

Component

removeListener( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes an event handler.
Removes an event handler.
Parameters:

- `eventName` : String
  The type of event the handler was associated with.
- `handler` : Function
  The handler to remove. This must be a reference to the function passed into the addListener call.
- `scope` : Object
  (optional) The scope originally specified for the handler.

Returns:

- void

Observable

render( [`Element/HTMLElement/String container`], [`String/Number position`] ) : void
Render this Component into the passed HTML element. If you are using a Container object to house this Component, then...

Render this Component into the passed HTML element.

If you are using a Container object to house this Component, then do not use the render method.

A Container's child Components are rendered by that Container's layout manager when the Container is first rendered.

Certain layout managers allow dynamic addition of child components. Those that do include Ext.layout.CardLayout, Ext.layout.AnchorLayout, Ext.layout.FormLayout, Ext.layout.TableLayout.

If the Container is already rendered when a new child Component is added, you may need to call the Container's doLayout to refresh the view which causes any unrendered child Components to be rendered. This is required so that you can add multiple child components if needed while only refreshing the layout once.

When creating complex UIs, it is important to remember that sizing and positioning of child items is the responsibility of the Container's layout manager. If you expect child items to be sized in response to user interactions, you must configure the Container with a layout manager which creates and manages the type of layout you have in mind.

Omitting the Container's layout config means that a basic layout manager is used which does nothing but render child components sequentially into the Container. No sizing or positioning will be performed in this situation.

Parameters:

- `container` : Element/HTMLElement/String
  (optional) The element this Component should be rendered into. If it is being created from existing markup, this should be omitted.
- `position` : String/Number
  (optional) The element ID or DOM node index within the container before which this component will be inserted (defaults to appending to the end of the container)

Returns:

- void

Component

resumeEvents() : void
Resume firing events. (see suspendEvents) If events were suspended using the queueSuspended parameter, then all event...
Resume firing events. (see suspendEvents) If events were suspended using the `queueSuspended` parameter, then all events fired during event suspension will be sent to any listeners now.
Parameters:

- None.

Returns:

- void

Observable

setDisabled( `Boolean disabled` ) : Ext.Component
Convenience function for setting disabled/enabled by boolean.
Convenience function for setting disabled/enabled by boolean.
Parameters:

- `disabled` : Boolean

Returns:

- `Ext.Component`
  this

Component

setSize( `Number width`, `Number height` ) : void
Sets the height and width of this editor.
Sets the height and width of this editor.
Parameters:

- `width` : Number
  The new width
- `height` : Number
  The new height

Returns:

- void

Editor

setValue( `Mixed value` ) : void
Sets the data value of the editor
Sets the data value of the editor
Parameters:

- `value` : Mixed
  Any valid value supported by the underlying field

Returns:

- void

Editor

setVisible( `Boolean visible` ) : Ext.Component
Convenience function to hide or show this component by boolean.
Convenience function to hide or show this component by boolean.
Parameters:

- `visible` : Boolean
  True to show, false to hide

Returns:

- `Ext.Component`
  this

Component

show() : Ext.Component
Show this component. Listen to the 'beforeshow' event and return false to cancel showing the component. Fires the '...
Show this component. Listen to the 'beforeshow' event and return `false` to cancel showing the component. Fires the 'show' event after showing the component.
Parameters:

- None.

Returns:

- `Ext.Component`
  this

Component

startEdit( `Mixed el`, [`String value`] ) : void
Starts the editing process and shows the editor.
Starts the editing process and shows the editor.
Parameters:

- `el` : Mixed
  The element to edit
- `value` : String
  (optional) A value to initialize the editor with. If a value is not provided, it defaults to the innerHTML of el.

Returns:

- void

Editor

suspendEvents( `Boolean queueSuspended` ) : void
Suspend the firing of all events. (see resumeEvents)
Suspend the firing of all events. (see resumeEvents)
Parameters:

- `queueSuspended` : Boolean
  Pass as true to queue up suspended events to be fired after the resumeEvents call instead of discarding all suspended events;

Returns:

- void

Observable

triggerEdit( `node {Ext.tree.TreeNode}` ) : void
Edit the text of the passed TreeNode.
Edit the text of the passed TreeNode.
Parameters:

- `{Ext.tree.TreeNode}` : node
  The TreeNode to edit. The TreeNode must be editable.

Returns:

- void

TreeEditor

un( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes an event handler (shorthand for removeListener.)
Removes an event handler (shorthand for removeListener.)
Parameters:

- `eventName` : String
  The type of event the handler was associated with.
- `handler` : Function
  The handler to remove. This must be a reference to the function passed into the addListener call.
- `scope` : Object
  (optional) The scope originally specified for the handler.

Returns:

- void

Observable

update( `Mixed htmlOrData`, [`Boolean loadScripts`], [`Function callback`] ) : void
Update the content area of a component.
Update the content area of a component.
Parameters:

- `htmlOrData` : Mixed
  If this component has been configured with a template via the tpl config then it will use this argument as data to populate the template. If this component was not configured with a template, the components content area will be updated via Ext.Element update
- `loadScripts` : Boolean
  (optional) Only legitimate when using the html configuration. Defaults to false
- `callback` : Function
  (optional) Only legitimate when using the html configuration. Callback to execute when scripts have finished loading

Returns:

- void

Component

## Public Events

Event | Defined By
--- | ---

added : ( `Ext.Component this`, `Ext.Container ownerCt`, `number index` )
Fires when a component is added to an Ext.Container
Fires when a component is added to an Ext.Container
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `ownerCt` : Ext.Container
  Container which holds the component
- `index` : number
  Position at which the component was added

Component

afterrender : ( `Ext.Component this` )
Fires after the component rendering is finished. The afterrender event is fired after this Component has been rendere...

Fires after the component rendering is finished.

The afterrender event is fired after this Component has been rendered, been postprocesed by any afterRender method defined for the Component, and, if stateful, after state has been restored.

Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

beforecomplete : ( `Editor this`, `Mixed value`, `Mixed startValue` )
Fires after a change has been made to the field, but before the change is reflected in the underlying field. Saving ...
Fires after a change has been made to the field, but before the change is reflected in the underlying field. Saving the change to the field can be canceled by returning false from the handler of this event. Note that if the value has not changed and ignoreNoChange = true, the editing will still end but this event will not fire since no edit actually occurred.
Listeners will be called with the following arguments:

- `this` : Editor
- `value` : Mixed
  The current field value
- `startValue` : Mixed
  The original field value

Editor

beforedestroy : ( `Ext.Component this` )
Fires before the component is destroyed. Return false from an event handler to stop the destroy.
Fires before the component is destroyed. Return false from an event handler to stop the destroy.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

beforehide : ( `Ext.Component this` )
Fires before the component is hidden by calling the hide method. Return false from an event handler to stop the hide.
Fires before the component is hidden by calling the hide method. Return false from an event handler to stop the hide.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

beforerender : ( `Ext.Component this` )
Fires before the component is rendered. Return false from an event handler to stop the render.
Fires before the component is rendered. Return false from an event handler to stop the render.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

beforeshow : ( `Ext.Component this` )
Fires before the component is shown by calling the show method. Return false from an event handler to stop the show.
Fires before the component is shown by calling the show method. Return false from an event handler to stop the show.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

beforestartedit : ( `Editor this`, `Ext.Element boundEl`, `Mixed value` )
Fires when editing is initiated, but before the value changes. Editing can be canceled by returning false from the h...
Fires when editing is initiated, but before the value changes. Editing can be canceled by returning false from the handler of this event.
Listeners will be called with the following arguments:

- `this` : Editor
- `boundEl` : Ext.Element
  The underlying element bound to this editor
- `value` : Mixed
  The field value being set

Editor

beforestaterestore : ( `Ext.Component this`, `Object state` )
Fires before the state of the component is restored. Return false from an event handler to stop the restore.
Fires before the state of the component is restored. Return false from an event handler to stop the restore.
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `state` : Object
  The hash of state values returned from the StateProvider. If this event is not vetoed, then the state object is passed to `applyState`. By default, that simply copies property values into this Component. The method maybe overriden to provide custom state restoration.

Component

beforestatesave : ( `Ext.Component this`, `Object state` )
Fires before the state of the component is saved to the configured state provider. Return false to stop the save.
Fires before the state of the component is saved to the configured state provider. Return false to stop the save.
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `state` : Object
  The hash of state values. This is determined by calling `getState()` on the Component. This method must be provided by the developer to return whetever representation of state is required, by default, Ext.Component has a null implementation.

Component

canceledit : ( `Editor this`, `Mixed value`, `Mixed startValue` )
Fires after editing has been canceled and the editor's value has been reset.
Fires after editing has been canceled and the editor's value has been reset.
Listeners will be called with the following arguments:

- `this` : Editor
- `value` : Mixed
  The user-entered field value that was discarded
- `startValue` : Mixed
  The original field value that was set back into the editor after cancel

Editor

complete : ( `Editor this`, `Mixed value`, `Mixed startValue` )
Fires after editing is complete and any changed value has been written to the underlying field.
Fires after editing is complete and any changed value has been written to the underlying field.
Listeners will be called with the following arguments:

- `this` : Editor
- `value` : Mixed
  The current field value
- `startValue` : Mixed
  The original field value

Editor

destroy : ( `Ext.Component this` )
Fires after the component is destroyed.
Fires after the component is destroyed.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

disable : ( `Ext.Component this` )
Fires after the component is disabled.
Fires after the component is disabled.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

enable : ( `Ext.Component this` )
Fires after the component is enabled.
Fires after the component is enabled.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

hide : ( `Ext.Component this` )
Fires after the component is hidden. Fires after the component is hidden when calling the hide method.
Fires after the component is hidden. Fires after the component is hidden when calling the hide method.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

removed : ( `Ext.Component this`, `Ext.Container ownerCt` )
Fires when a component is removed from an Ext.Container
Fires when a component is removed from an Ext.Container
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `ownerCt` : Ext.Container
  Container which holds the component

Component

render : ( `Ext.Component this` )
Fires after the component markup is rendered.
Fires after the component markup is rendered.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

show : ( `Ext.Component this` )
Fires after the component is shown when calling the show method.
Fires after the component is shown when calling the show method.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

specialkey : ( `Ext.form.Field this`, `Ext.EventObject e` )
Fires when any key related to navigation (arrows, tab, enter, esc, etc.) is pressed. You can check Ext.EventObject.g...
Fires when any key related to navigation (arrows, tab, enter, esc, etc.) is pressed. You can check Ext.EventObject.getKey to determine which key was pressed.
Listeners will be called with the following arguments:

- `this` : Ext.form.Field
- `e` : Ext.EventObject
  The event object

Editor

startedit : ( `Ext.Element boundEl`, `Mixed value` )
Fires when this editor is displayed
Fires when this editor is displayed
Listeners will be called with the following arguments:

- `boundEl` : Ext.Element
  The underlying element bound to this editor
- `value` : Mixed
  The starting field value

Editor

staterestore : ( `Ext.Component this`, `Object state` )
Fires after the state of the component is restored.
Fires after the state of the component is restored.
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `state` : Object
  The hash of state values returned from the StateProvider. This is passed to `applyState`. By default, that simply copies property values into this Component. The method maybe overriden to provide custom state restoration.

Component

statesave : ( `Ext.Component this`, `Object state` )
Fires after the state of the component is saved to the configured state provider.
Fires after the state of the component is saved to the configured state provider.
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `state` : Object
  The hash of state values. This is determined by calling `getState()` on the Component. This method must be provided by the developer to return whetever representation of state is required, by default, Ext.Component has a null implementation.

Component